--- vls.orig/src/modules/videoinput/videoinput.cpp	2003-08-11 11:15:48.000000000 +0100
+++ vls/src/modules/videoinput/videoinput.cpp	2003-08-12 22:20:36.000000000 +0100
@@ -181,7 +181,7 @@
     pBuffer = new C_SyncFifo(uiSize);
     // Get file name
     strReaderType = "file";
-    pBroadcast->SetOption("device", m_strDevice);
+    pBroadcast->SetOption("filename", m_strDevice);
 
     // Converter configuration
     strConverterType = "ts2ts";
@@ -293,8 +293,8 @@
     pTrickPlay->Stop();
 
     // Unregister the 2 thread and delete them
-    m_cStreamers.Delete(pBroadcast);
     m_cTrickPlay.Delete(pBroadcast);
+    m_cStreamers.Delete(pBroadcast);
 
     throw E_Exception(GEN_ERR, "unable to start streaming of program "+
                       pBroadcast->GetProgram()->GetName(), e);
@@ -382,9 +382,9 @@
   try
   {
     pStreamer->Stop();
-    delete pStreamer;
     pTrickPlay->Stop();
     delete pTrickPlay;
+    delete pStreamer; // streamer MUST be deleted last
   }
   catch(E_Exception e)
   {
